// No jQuery dependency else we will have problems.
(function () {
  "use strict";
  var d = document;

  var settingsElement = document.querySelector('head > script[type="application/json"][data-drupal-selector="drupal-settings-json"], body > script[type="application/json"][data-drupal-selector="drupal-settings-json"]');
  window.drupalSettings = {};
  if (settingsElement !== null) {
    window.drupalSettings = JSON.parse(settingsElement.textContent);
  }
  var master = window.drupalSettings.micro_sso.master;

  // Fetch unix timestamp.
  function n() {
    return Math.floor(Date.now() / 1000);
  }

  // Tell the browser to stop checking for a while.
  function stop() {
    d.cookie = "micro_sso=" + (n() + 600); // 10 minutes.
  }

  // Can the broswer attempt?
  function may() {
    var match = d.cookie.match(/micro_sso=([\d]+)(;|$)/);
    return !match || match[1] < n();
  }

  if (may() && master) {
    var x = new XMLHttpRequest();

    x.open("GET", master);
    x.withCredentials = true;
    x.setRequestHeader("Accept", "application/json");
    x.onerror = function () {
      stop();
    };
    x.onload = function () {
      try {
        var d = JSON.parse(this.responseText);
        if (d.status && d.uri) {
          window.location.href = d.uri + "&destination=" + window.location.href;
        }
        stop();
      } catch (e) {
        stop();
      }
    };
    x.send();
  }
}());